<?php
/**
* @version $Id$
* @package plug_cbkarma
* @subpackage karma.php
* @author A. Korologos & M. Galang
* @copyright (C) 2006 www.galangph.com
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


class getkarmaTab extends cbTabHandler {
	/**
	 * Construnctor
	 */
	function getkarmaTab() {
		$this->cbTabHandler();
	}
	
	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab,$user,$ui) {
		global $database, $my, $mosConfig_live_site, $mosConfig_absolute_path;

		$myIP = $GLOBALS['REMOTE_ADDR']; 
		$currentDate = mosCurrentDate("%Y-%m-%d");
		
		$return = null;
		
		//com_karma class
		require_once($mosConfig_absolute_path . "/components/com_karma/karma.class.php");
		
		//js includes
		$return .= "<script type=\"text/javascript\" language=\"javascript\" src=\"$mosConfig_live_site/components/com_comprofiler/plugin/user/plug_cbkarma/js/prototype.lite.js\"></script>";
		$return .= "<script type=\"text/javascript\" language=\"javascript\" src=\"$mosConfig_live_site/components/com_comprofiler/plugin/user/plug_cbkarma/js/moo.ajax.js\"></script>";
		$return .= "<script type=\"text/javascript\" language=\"javascript\" src=\"$mosConfig_live_site/components/com_comprofiler/plugin/user/plug_cbkarma/js/karma.js\"></script>";
		
		//get current karma values
		$sql = "select * from `#__karma_tb` where `user_id` = '$user->id' limit 1";
		$database->setQuery($sql);
		$row = $database->loadObjectList();
		$row=$row[0];
		
		$return .= "<strong>This month's karma: </strong> " . $row->var_karma . "<br />";
		$return .= "<strong>Total karma: </strong> " . $row->total_karma . "<br />";
		
		//run a set of rule checking (for security)
		$valid = true;
		
		//Prevent users from rating themselves
		if($my->id == $user->id)
			$valid = false;
		
		if($this->matchUserIp($my->id, $user->id, $myIP) && $valid){
			//validate day lock
			$valid_date = $this->offsetTimestamp($my->id, $user->id, $myIP, CLASS_karma::getConfig('daylock'));
						
			if(isset($valid_date) && $valid_date != ''){
				if(strtotime($valid_date) > strtotime($currentDate)){
					$valid = false;
				}
			}
		} else {
			//query DB for log entries with similar IP and user
			if($logs =& $this->fetchLogByIp($myIP, $user->id) != false){
				$log = $logs[0];
				
				if(($log->ip == $myIP) && ($log->my_id != $my->id)){ 
					//If user has a previous similar IP log but different username, he might be spoofing
					//So therefore we prevent him from rating the user
					$valid = false;
				} elseif(($log->ip != $myIP) && ($log->my_id == $my->id)){					
					//validate day lock
					$valid_date = $this->offsetTimestamp($my->id, $user->id, $myIP, CLASS_karma::getConfig('daylock'));
					
					if(isset($valid_date) && $valid_date != ''){
						if(strtotime($valid_date) > strtotime($currentDate)){
							$valid = false;
						}
					}
				}
			}
		}
		
		if($valid && $my->id){
			$return .= "<br /><div id=\"ratebox\">";
			$return .= "<span style=\"font-size: 14px; font-weight: bold;\">Rate this user: </span>";
			$return .= "<span style=\"cursor:pointer; font-size: 14px; font-weight: bold;\" onClick=\"rateKarma('" . $user->id. "', '" . $my->id. "', '" . $myIP . "', '1');\"><img src=\"$mosConfig_live_site/components/com_comprofiler/plugin/user/plug_cbkarma/image/thumbup.gif\" /></span>&nbsp;";
			$return .= "<span style=\"cursor:pointer; font-size: 14px; font-weight: bold;\" onClick=\"rateKarma('" . $user->id. "', '" . $my->id. "', '" . $myIP . "', '0');\"><img src=\"$mosConfig_live_site/components/com_comprofiler/plugin/user/plug_cbkarma/image/thumbdown.gif\" /></span>";
			$return .= "</div>";
		}
		
		return $return;
	} // end or getDisplayTab function
	
	function matchUserIp($myid, $userid, $ip){
		global $database;
		$sql = "select count(id) from `#__karma_log` where `my_id` = '$myid' and `user_id` = '$userid' and `ip` = '$ip'";
		$database->setQuery($sql);
		
		return intval($database->loadResult());
	}
	
	function fetchLogByIP($ip, $userid){
		global $database;
		
		$sql = "select * from `#__karma_log` where `ip` = '$ip' and `user_id` = '$userid' order by `timestamp` DESC";
		$database->setQuery($sql);
		$rows = $database->loadObjectList();
		
		if(count($rows)){
			return $rows;
		}
		return false;
	}
	
	function offsetTimestamp($myid, $userid, $ip, $offset){
		global $database;
		
		$sql = "select date(DATE_ADD(`timestamp`,INTERVAL $offset DAY)) as date \n" .
			"from `#__karma_log` \n" .
			"where `user_id` = '$userid' \n" .
			"and `my_id` = '$myid' \n".
			"and `ip` = '$ip' \n".
			"order by `timestamp` DESC \n" .
			"limit 1 \n";
			
		$database->setQuery($sql);
		return $database->loadResult();
	}
	
} // end of the world. :)
?>